//------------------------------------------------------------------
//
//
//------------------------------------------------------------------
//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers  5
#property strict


extern int    ValueBuffer        = 3;          // "Value" buffer number
extern int    SlopeBuffer        = 10;         // "Trend" buffer number
extern color  colorUp            = clrLime;
extern color  colorDown          = clrRed;
extern color  colorNeutral       = clrDimGray;
extern int    linesWidth         = 3;
extern string IndicatorName      = "Smoother (r-squared) adaptive (experiment)"; // Indicator name to use
extern int    YDistance          = 262;
extern int    XDistance          = 2;
extern string ButtonID           = "Smoother(r-sqr)";

bool returnBars;

double Value[],ValueUa[],ValueUb[],ValueDa[],ValueDb[],slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
int init() 
{
   IndicatorBuffers(6);
   SetIndexBuffer(0, Value);   SetIndexStyle(0,EMPTY,EMPTY,linesWidth,colorNeutral);
   SetIndexBuffer(1, ValueUa); SetIndexStyle(1,EMPTY,EMPTY,linesWidth,colorUp);
   SetIndexBuffer(2, ValueUb); SetIndexStyle(2,EMPTY,EMPTY,linesWidth,colorUp);
   SetIndexBuffer(3, ValueDa); SetIndexStyle(3,EMPTY,EMPTY,linesWidth,colorDown);
   SetIndexBuffer(4, ValueDb); SetIndexStyle(4,EMPTY,EMPTY,linesWidth,colorDown);
   SetIndexBuffer(5, slope); 
      
   IndicatorShortName("Exploring buffers ("+(string)ValueBuffer+","+(string)SlopeBuffer+") of "+IndicatorName);
   
   if (ObjectFind(ButtonID)!=0)
   {
       ObjectCreate(ChartID(),ButtonID,OBJ_BUTTON,WindowOnDropped(),0,0);
         ObjectSetString(ChartID(),ButtonID,OBJPROP_TEXT,ButtonID+" is on");
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_FONTSIZE,10);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_YDISTANCE,YDistance);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_XDISTANCE,XDistance);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_XSIZE,190);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_YSIZE,20);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),ButtonID,OBJPROP_STATE,true);
   }
   return(0);
}
//---+
void OnDeinit(const int reason)
{ 
   if (!returnBars)
      switch(reason)
      {
         case REASON_PARAMETERS  :
         case REASON_CHARTCHANGE :
         case REASON_RECOMPILE   :
         case REASON_CLOSE       : break;
         default :
         {
            ObjectDelete(ButtonID);
         }                  
      }
}
//---+
//
//
//
//
//
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
{
   static string prevState ="";
   if (id==CHARTEVENT_OBJECT_CLICK && sparam==ButtonID)
   {
   string newState = GetButtonState(ButtonID);
         if (newState!=prevState)
         if (newState=="off")
         { 
            for (int i=0; i<7; i++) SetIndexStyle(i,DRAW_NONE);
            prevState=newState;
         }
         else  
         { 
            for (int i=0; i<7; i++) SetIndexStyle(i,DRAW_LINE);
            prevState=newState;
         }
         
           ObjectSetString(ChartID(),ButtonID,OBJPROP_TEXT,ButtonID+" is "+newState);
   }
}

int start() 
{
   
  
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
         
         if (slope[limit]== 1) CleanPoint(limit,ValueUa,ValueUb);
         if (slope[limit]==-1) CleanPoint(limit,ValueDa,ValueDb);
         
   for(int i=limit; i>=0; i--)
   {
      
      if (i<Bars-1) 
      {
         if (ValueBuffer>=0) Value[i] = iCustom(NULL,0,IndicatorName,0,25,21,0.0,0,1,25,90.0,10.0,0,32768,17919,5197615,3223838,5,true,ValueBuffer,i);
         if (SlopeBuffer>=0) slope[i] = iCustom(NULL,0,IndicatorName,0,25,21,0.0,0,1,25,90.0,10.0,0,32768,17919,5197615,3223838,5,true,SlopeBuffer,i);
         
          ValueDa[i] = EMPTY_VALUE;
          ValueDb[i] = EMPTY_VALUE;
          ValueUa[i] = EMPTY_VALUE;
          ValueUb[i] = EMPTY_VALUE;
   
               
          if (slope[i]== 1) PlotPoint(i,ValueUa,ValueUb,Value);
          if (slope[i]==-1) PlotPoint(i,ValueDa,ValueDb,Value);
          
      } 
    }
   if(slope[0] == 1) ObjectSetInteger(ChartID(),ButtonID,OBJPROP_BGCOLOR,clrGreen);
   if(slope[0] == 0) ObjectSetInteger(ChartID(),ButtonID,OBJPROP_BGCOLOR,clrDimGray);
   if(slope[0] ==-1) ObjectSetInteger(ChartID(),ButtonID,OBJPROP_BGCOLOR,clrFireBrick);
      
   return(0); 
}
//
//
//
//
//
//
//---+
void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
//---+
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}
//---+
string GetButtonState(string whichbutton)
{
    bool selected=ObjectGetInteger(ChartID(),whichbutton,OBJPROP_STATE);
    if (selected)
        {return ("on");} 
    else
        {return ("off");}
}